// Script Name: Swimming_Fish_Rezzer.lsl
// Author: Anonymous
// FISH-O-MATIC Fish generator.  
//
//A fish swimming script for random motions.  Put the fish inside the rezzer object along with the rezzer script. Click the rezzer, Menu for height, width and fish to rez appears.  The fish will swim randomly around inside that area.
//

// Downloaded from : http://www.free-lsl-scripts.com/cgi/freescripts.plx?ID=907

// This program is free software; you can redistribute it and/or modify it.
// Additional Licenes may apply that prevent you from selling this code
// and these licenses may require you to publish any changes you make on request.
//
// There are literally thousands of hours of work in these scripts. Please respect
// the creators wishes and Copyright law and follow their license requirements.
//
// License information included herein must be included in any script you give out or use.
// Licenses may also be included in the script or comments by the original author, in which case
// the authors license must be followed, and  their licenses override any licenses outlined in this header.
//
// You cannot attach a license to any of these scripts to make any license more or less restrictive.
//
// All scripts by avatar Ferd Frederix, unless stated otherwise in the script, are licensed as Creative Commons By Attribution and Non-Commercial.
// Commercial use is NOT allowed - no resale of my scripts in any form.  
// This means you cannot sell my scripts but you can give them away if they are FREE.  
// Scripts by Ferd Frederix may be sold when included in a new object that actually uses these scripts. Putting my script in a prim and selling it on marketplace does not constitute a build.
// For any reuse or distribution, you must make clear to others the license terms of my works. This is done by leaving headers intact.
// See http://creativecommons.org/licenses/by-nc/3.0/ for more details and the actual license agreement.
// You must leave any author credits and any headers intact in any script you use or publish.
///////////////////////////////////////////////////////////////////////////////////////////////////
// If you don't like these restrictions and licenses, then don't use these scripts.
//////////////////////// ORIGINAL AUTHORS CODE BEGINS ////////////////////////////////////////////
// Fish script
// swimming swim script for use with the FISH-O-Matic

integer chanFish = 10; // fish listen on this channel
vector dest;

default
{
    state_entry()
    {
        llListen(chanFish, "", "", "" );
    }

    listen(integer channel, string noname, key id, string message)
    {
        
        list cmds  = llParseString2List( message, [","], [""] );
        string cmd = llList2String(cmds,0);
        if (cmd == "die")
            llDie();
        else if (cmd == "target")
        {
            string name = llList2String(cmds,1);
            
            if ( name != llGetObjectName() )
                return;
            
            string X= llList2String(cmds,2);
            string Y= llList2String(cmds,3);
            string Z= llList2String(cmds,4);
    
            dest = <(float) X,(float) Y,(float) Z>;
    
            llSetTimerEvent(0.5);    // swim every half second.   The slower this is, the more fish-like
            llSetStatus(STATUS_PHYSICS,TRUE);
        }
    }

    timer()
    {
        llLookAt(dest,0.5,0.2);
        llMoveToTarget(dest,5);   // go there in 5 seconds
    }
    
    on_rez(integer start_num)
    {
        llResetScript();
    }
}

